<?php
/*
Plugin Name: Flash Album Gallery Extras
Plugin URI: http://dev.himmelrath.net/fage
Description: (Random/Latest) Picture Widget
Version: 0.4a
Author: Jens Himmelrath
Author URI: http://himmelrath.net
*/

/*  Copyright 2009  Jens Himmelrath  (email : jens@himmelrath.net)

    This program is almost free software; you can redistribute it and/or modify
    it under the terms of the Mi License

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

    You can find the Mi License under the following URL:
    http://dev.himmelrath.net/mi-license.txt

*/



/*
 * Version history:
 *
 *  0.4a
 *    Cache workaround
 *    - When WP-Cache is active, the "random" picture does not change as long as the
 *      cache is active. The widget now gives an option to work around the cache by
 *      showing the thumbnail through a script instead of the static file. Only
 *      problem is the gallery link which might show a wrong starting image if more
 *      than one version of the webpage is opened.
 *
 *  0.3a
 *    Database access
 *    - Reads picture information from the database instead of the filesystem
 *
 *  0.2a
 *    Excerpt cleaner
 *    - New Feature: Cleans the [flagallery]-tags from excerpts
 *
 *  0.1a
 *    First Version.
 *    - Random/Latest picture widget. (Read from filesystem)
 *
 *
 */

// Never call this script directly...
if (empty($GLOBALS['wpdb'])) {
    die('Go ahead. Make my day...');
}


define('FAG_RELDIR', '/plugins/flagallery');
define('FAG_CONTENTDIR', WP_CONTENT_DIR . FAG_RELDIR);
define('FAG_DIRURL', WP_CONTENT_URL . FAG_RELDIR);
define('FAGE_RELDIR', '/plugins/flash-album-gallery-extras');
define('FAGE_DIR', dirname(__FILE__));
define('FAGE_DIRURL', WP_CONTENT_URL . FAGE_RELDIR);

define('FAGE_ANTICAHE_RANDOM_THUMB', FAGE_DIRURL . '/randomImage.php');
define('FAGE_ANTICAHE_LATEST_THUMB', FAGE_DIRURL . '/latestImage.php');

if (!defined('CURRENT_URL')) {
    define('CURRENT_URL', $_SERVER['PHP_SELF'] .'?page='. urlencode($_GET['page']));
}


// RandomImage widget
require_once FAGE_DIR. '/include/fagepicturewidget.class.php';
require_once FAGE_DIR. '/include/fagetools.class.php';

add_action(
    'widgets_init',
    create_function('', 'return register_widget("FagePictureWidget");')
);



// Filter gallery from post content before excerpt creation
add_filter(
    'get_the_excerpt',
    'miFilterExcerpt',
    1
); /**/

function miFilterExcerpt($text) {
    global $post;
    
    // $text is the manual excerpt text
    $text = trim($text);
    
    if ($text == '') {
        $content =& $post->post_content;
    } else {
        $content =& $text;
    }
    
    $content = preg_replace(
        '#\[flagallery(.*?)\]#s',
        '',
        $content
    );
    
    return $text;
}

